package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class LateFeeFrame extends JFrame {
  GridLayout gridLayout1 = new GridLayout();
  JLabel lblBookTitle = new JLabel();
  JButton btnPayFee = new JButton();
  JButton btnClose = new JButton();

  PnlMemberBooks pnlMemberBooks;
  JTextField txtAmountDue = new JTextField();
  JLabel lblAmountDue = new JLabel();
  JComboBox cmbBookTitle = new JComboBox();
  JCheckBox chkBlackListed = new JCheckBox();
  JPanel Empty = new JPanel();
  JTextField txtBookAmount = new JTextField();
  JLabel lblBookAmount = new JLabel();

  public LateFeeFrame() {
    jbInit();
  }

  public LateFeeFrame(PnlMemberBooks pnlMemberBooks) {
    this.pnlMemberBooks = pnlMemberBooks;
    jbInit();
  }

  private void jbInit() {
    this.getContentPane().setLayout(new GridLayout(5,2));
    this.setTitle("Inventory");

    lblBookTitle.setText("Book Title");
    btnPayFee.setEnabled(false);
    btnPayFee.setText("Pay Fee");
    btnClose.setText("Close");
    btnClose.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnClose_actionPerformed(e);
      }
    });

    lblAmountDue.setRequestFocusEnabled(true);
    lblAmountDue.setToolTipText("");
    lblAmountDue.setText("Fee Amount Due");

    chkBlackListed.setToolTipText("");
    chkBlackListed.setText("Black Listed");
    lblBookAmount.setVerifyInputWhenFocusTarget(true);
    lblBookAmount.setText("Amount of Books on Loan");
    lblBookAmount.setRequestFocusEnabled(true);
    this.getContentPane().add(lblBookTitle, null);
    this.getContentPane().add(cmbBookTitle, null);

    this.getContentPane().add(lblAmountDue, null);
    this.getContentPane().add(txtAmountDue, null);
    this.getContentPane().add(lblBookAmount, null);
    this.getContentPane().add(txtBookAmount, null);



    this.getContentPane().add(chkBlackListed, null);
    this.getContentPane().add(Empty, null);
    this.getContentPane().add(btnClose, null);
    this.getContentPane().add(btnPayFee, null);
    lblAmountDue.setVerifyInputWhenFocusTarget(true);
  }

  void btnClose_actionPerformed(ActionEvent e) {
    this.setVisible(false);
  }
}
