package gui_design_and_implimentation;

import java.util.Vector;

public class Member{

  private Vector member;

  private String memberNumber;
  private String firstname;
  private String surname;
  private String telephone;
  private String street;
  private String city;
  private String joinDate;
  private Vector book;

  public Member() {
  }

  public Member(String aMemberNumber, String aFirstname, String aSurname, String aTelephone, String aStreet, String aCity, String aJoinDate) {
    this.memberNumber = aMemberNumber;
    this.firstname = aFirstname;
    this.surname = aSurname;
    this.telephone = aTelephone;
    this.street = aStreet;
    this.city = aCity;
    this.joinDate = aJoinDate;
    book = new Vector();
  }

  public String getMemberNumber(){
    return memberNumber;
  }
  public String getFirstname(){
    return firstname;
  }
  public String getSurname(){
    return surname;
  }
  public String getTelephone(){
    return telephone;
  }
  public String getStreet(){
    return street;
  }
  public String getCity(){
    return city;
  }
  public String getAmount(){
    return joinDate;
  }


  public String toString() {
      return "Member Number: " + memberNumber+", First Name: "+firstname+", Surname: "+surname+", Telephone Number: "+telephone+"|| Address Street:"+street+", City: "+city+"|| Join Date: "+joinDate + "\n Books: " + book;
  }


  /////////////////////////////////
  /**
   * The one-to-Many association with Members
   * @param Member
   */
  public void setMember(Vector newMember){
    this.member = newMember;
  }
  public Vector getMember(){
    return this.member;
  }

  public void setBook(Vector newBook){
    this.book = newBook;
  }
  public Vector getBook(){
    return this.book;
  }
   /////////////////////////////////


}
