package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;
import javax.swing.border.*;


public class PnlAddLibraryBooks extends JPanel {

  LibraryBooks library = new LibraryBooks();
  AddBooksFrame addBooksFrame;
  BorderLayout borderLayout1 = new BorderLayout();
  FlowLayout flowLayout1 = new FlowLayout();
  DefaultTableModel model;
  JPanel pnlSouth = new JPanel();
  JScrollPane scrLibrary = new JScrollPane();
  JTable bookTable = new JTable();
  JButton btnAddBook = new JButton("Add Inventory");
  JButton btnRefresh = new JButton("Refresh");
  JButton btnReturn = new JButton();

  Vector columns = new Vector();
  Vector data = new Vector();
  Vector addBooks = new Vector();
  Main main;

  public PnlAddLibraryBooks(Main main) {
    this.main=main;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    btnReturn.setEnabled(false);
    btnRefresh.setEnabled(false);
    this.add(scrLibrary,  BorderLayout.CENTER);
    this.add(pnlSouth, BorderLayout.SOUTH);

    btnAddBook.setText("Add Book");
    btnAddBook.addActionListener(new PnlAddLibraryBooks_btnAddBook_actionAdapter(this));

    btnReturn.setText("Remove Book");

    pnlSouth.setLayout(flowLayout1);
    pnlSouth.add(btnAddBook);
    pnlSouth.add(btnReturn, null);
    pnlSouth.add(btnRefresh);

    scrLibrary.getViewport().add(bookTable, null);
    setColumns();
  }

  void btnAddBook_actionPerformed(ActionEvent e) {
    addBooksFrame = new AddBooksFrame(main);
    addBooksFrame.setVisible(true);
    addBooksFrame.pack();
  }

  public void addBook(Book book){
    this.addBooks.add(book);
    this.library.getBook().setBook(addBooks);
    display();
  }

  private void setColumns(){
    columns.add("ISBN");
    columns.add("Publisher");
    columns.add("Author");
    columns.add("Title");
    columns.add("Amount");
  }

  void btnRefresh_actionPerformed(ActionEvent e) {
    display();
  }

  private void display() {
    data = new Vector();
    addBooks = library.getBook().getBook();
    for (int i =0; i<addBooks.size(); i++) {
      Book libraryBooks = (Book) addBooks.get(i);
      Vector row = new Vector();
      row.add(libraryBooks.getISBN());
      row.add(libraryBooks.getPublisher());
      row.add(libraryBooks.getAuthor());
      row.add(libraryBooks.getTitle());
      row.add(new Double(libraryBooks.getAmount()));
      data.add(row);
      System.out.println("Testing Library Book Storage"+"\n"+libraryBooks);
    }
    model = new DefaultTableModel(data, columns);
    bookTable.setModel(model);
  }

}

class PnlAddLibraryBooks_btnAddBook_actionAdapter implements java.awt.event.ActionListener {
  PnlAddLibraryBooks adaptee;

  PnlAddLibraryBooks_btnAddBook_actionAdapter(PnlAddLibraryBooks adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnAddBook_actionPerformed(e);
  }
}
