package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;
import javax.swing.border.*;
import javax.swing.table.TableColumnModel;


public class PnlLibraryBooks extends JPanel {

  LibraryBooks library = new LibraryBooks();
  AddBooksFrame addBooksFrame;
  BorderLayout borderLayout1 = new BorderLayout();
  DefaultTableModel model;
  JScrollPane scrLibrary = new JScrollPane();
  JTable bookTable = new JTable();

  Vector columns = new Vector();
  Vector data = new Vector();
  Vector books = new Vector();
  Main main;

  public PnlLibraryBooks(Main main) {
    this.main=main;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    this.add(scrLibrary,  BorderLayout.CENTER);


    scrLibrary.getViewport().add(bookTable, null);
    setColumns();
  }

  public void addBook(Book book){
    this.books.add(book);
    this.library.getBook().setBook(books);
    display();
  }

  private void setColumns(){
    columns.add("ISBN");
    columns.add("Publisher");
    columns.add("Author");
    columns.add("Title");
    columns.add("Amount");
  }

  void btnRefresh_actionPerformed(ActionEvent e) {
    display();
  }

  private void display() {
    data = new Vector();
    books = library.getBook().getBook();
    for (int i =0; i<books.size(); i++) {
      Book libraryBooks = (Book) books.get(i);
      Vector row = new Vector();
      row.add(libraryBooks.getISBN());
      row.add(libraryBooks.getPublisher());
      row.add(libraryBooks.getAuthor());
      row.add(libraryBooks.getTitle());
      row.add(new Double(libraryBooks.getAmount()));
      data.add(row);
      System.out.println("Testing Library Book Storage"+"\n"+libraryBooks);
    }
    model = new DefaultTableModel(data, columns);
    bookTable.setModel(model);
  }

  public Vector getBook() {
    int row = bookTable.getSelectedRow();
    Vector selectedBook = new Vector();
    TableColumnModel colModel = bookTable.getColumnModel();
    String isbn = (String)bookTable.getValueAt(row, 0);
    String publisher = (String)bookTable.getValueAt(row, 1);
    String author = (String)bookTable.getValueAt(row, 2);
    String title = (String)bookTable.getValueAt(row, 3);
    selectedBook.add(isbn);
    selectedBook.add(publisher);
    selectedBook.add(author);
    selectedBook.add(title);
    return selectedBook;
  }

  void btnLoan_actionPerformed(ActionEvent e) {
    int row = bookTable.getSelectedRow();
    TableColumnModel colModel = bookTable.getColumnModel();

    String isbn = (String)bookTable.getValueAt(row, 0);
    String publisher = (String)bookTable.getValueAt(row, 1);
    String author = (String)bookTable.getValueAt(row, 2);
    String title = (String)bookTable.getValueAt(row, 3);

    System.out.println("ISBN: " + isbn + ", Publisher: " + publisher + ", Author: " + author + ", Title: " + title);
  }
}
