package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumnModel;

public class PnlMember
    extends JPanel {

  JLabel lblMemberNo = new JLabel();
  JTextField txtMemberNo = new JTextField();
  JTextField txtFirstname = new JTextField();
  JLabel lblFirstname = new JLabel();
  JTextField txtSurname = new JTextField();
  JLabel lblSurname = new JLabel();
  JLabel lblTelephone = new JLabel();
  JTextField txtTelephone = new JTextField();
  JTextField txtStreet = new JTextField();
  JLabel lblStreet = new JLabel();
  JTextField txtCity = new JTextField();
  JLabel lblCity = new JLabel();
  JLabel lblHireDate = new JLabel();
  JTextField txtHireDate = new JTextField();
  JButton btnSearch = new JButton();
  JButton btnModify = new JButton();
  JButton btnDelete = new JButton();
  JButton btnAdd = new JButton();
  JPanel Empty02 = new JPanel();
  JPanel Empty01 = new JPanel();
  Membership membership = new Membership();
  Vector addMember = new Vector();
  Vector columns = new Vector();
  Vector data = new Vector();
  Vector books = new Vector();
  Vector addBook = new Vector();

  Main main;
  XYLayout xYLayout1 = new XYLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTable MemberTable = new JTable();
  DefaultTableModel model;

  public PnlMember(Main main) {
    this.main = main;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(xYLayout1);
    lblFirstname.setText("Firstname");
    txtFirstname.setText("");
    lblSurname.setText("Surname");
    txtSurname.setText("");
    lblTelephone.setText("Telephone");
    txtTelephone.setText("");
    lblStreet.setText("Street");
    txtStreet.setText("");
    lblCity.setText("City");
    txtCity.setText("");
    lblHireDate.setToolTipText("");
    lblHireDate.setVerifyInputWhenFocusTarget(true);
    lblHireDate.setText("Hire Date");
    txtHireDate.setText("");
    lblMemberNo.setToolTipText("");
    lblMemberNo.setText("Staff Number");
    txtMemberNo.setText("");
    btnSearch.setEnabled(false);
    btnSearch.setDoubleBuffered(false);
    btnSearch.setText("Search");
    btnModify.setEnabled(false);
    btnModify.setText("Modify");
    btnDelete.setEnabled(false);
    btnDelete.setText("Delete");
    btnAdd.setText("Add");
    btnAdd.addActionListener(new PnlMember_btnAdd_actionAdapter(this));
    xYLayout1.setWidth(698);
    xYLayout1.setHeight(300);
    this.add(lblMemberNo, new XYConstraints(0, 0, 151, 30));
    this.add(txtMemberNo, new XYConstraints(151, 0, 151, 30));
    this.add(lblFirstname, new XYConstraints(0, 30, 151, 30));
    this.add(txtFirstname, new XYConstraints(151, 30, 151, 30));
    this.add(lblSurname, new XYConstraints(0, 60, 151, 30));
    this.add(txtSurname, new XYConstraints(151, 60, 151, 30));
    this.add(lblTelephone, new XYConstraints(0, 90, 151, 30));
    this.add(txtTelephone, new XYConstraints(151, 90, 151, 30));
    this.add(lblStreet, new XYConstraints(0, 120, 151, 30));
    this.add(txtStreet, new XYConstraints(151, 120, 151, 30));
    this.add(lblCity, new XYConstraints(0, 150, 151, 30));
    this.add(txtCity, new XYConstraints(151, 150, 151, 30));
    this.add(lblHireDate, new XYConstraints(0, 180, 151, 30));
    this.add(txtHireDate, new XYConstraints(151, 180, 151, 30));
    this.add(Empty01, new XYConstraints(0, 210, 151, 30));
    this.add(Empty02, new XYConstraints(151, 210, 151, 30));
    this.add(btnSearch, new XYConstraints(0, 240, 151, 30));
    this.add(btnAdd, new XYConstraints(151, 240, 151, 30));
    this.add(btnModify, new XYConstraints(0, 270, 151, 30));
    this.add(btnDelete, new XYConstraints(151, 270, 151, 30));
    this.add(jScrollPane1, new XYConstraints(302, 1, 332, 299));
    jScrollPane1.getViewport().add(MemberTable, null);

    setColumns();
  }

  void btnAdd_actionPerformed(ActionEvent e) {
    try {
      create();
    }
    catch (Exception ex) {
      System.out.print("Error occured while creating Inventory");
    }
  }

  private void setColumns() {
    columns.add("Member Number");
    columns.add("Firstname");
    columns.add("Surname");
    columns.add("Telephone");
    columns.add("Street");
    columns.add("City");
    columns.add("Date Joined");
  }

  private void create() throws Exception {
    String aMemberNumber = this.txtMemberNo.getText();
    String aFirstname = this.txtFirstname.getText();
    String aSurname = this.txtSurname.getText();
    String aTelephone = this.txtTelephone.getText();
    String aStreet = this.txtStreet.getText();
    String aCity = this.txtCity.getText();
    String aHireDate = this.txtHireDate.getText();
    Member member = new Member(aMemberNumber, aFirstname, aSurname, aTelephone,aStreet, aCity, aHireDate);
    main.addMember(member);
  }

  public void add(Member member) {
    addMember(member);
  }

  public void addMember(Member member) {
    this.addMember.add(member);
    this.membership.getMember().setMember(addMember);
    display();
  }

  public void addBook(Book book) {
    this.addBook.add(book);
    this.membership.getMember().setBook(addBook);
    display();
  }


  private void display() {
    data = new Vector();
    books = membership.getMember().getMember();
    for (int i = 0; i < books.size(); i++) {
      Member currentMembers = (Member) books.get(i);
      Vector row = new Vector();
      row.add(currentMembers.getMemberNumber());
      row.add(currentMembers.getFirstname());
      row.add(currentMembers.getSurname());
      row.add(currentMembers.getTelephone());
      row.add(currentMembers.getStreet());
      row.add(currentMembers.getCity());
      row.add(currentMembers.getAmount());
      data.add(row);
      System.out.println("Testing Library Book Storage" + "\n" + currentMembers);
    }
    model = new DefaultTableModel(data, columns);
    MemberTable.setModel(model);
  }

  public Vector getMembersBook() {
    int row = MemberTable.getSelectedRow();
    Vector selectedBook = new Vector();
    TableColumnModel colModel = MemberTable.getColumnModel();
    String isbn = (String)MemberTable.getValueAt(row, 0);
    String publisher = (String)MemberTable.getValueAt(row, 1);
    String author = (String)MemberTable.getValueAt(row, 2);
    String title = (String)MemberTable.getValueAt(row, 3);
    selectedBook.add(isbn);
    selectedBook.add(publisher);
    selectedBook.add(author);
    selectedBook.add(title);
    return selectedBook;
  }


}

class PnlMember_btnAdd_actionAdapter
    implements java.awt.event.ActionListener {
  PnlMember adaptee;

  PnlMember_btnAdd_actionAdapter(PnlMember adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.btnAdd_actionPerformed(e);
  }
}
