package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class AddBooksFrame extends JFrame {
  GridLayout gridLayout1 = new GridLayout();
  JLabel lblISBN = new JLabel();
  JLabel lblPublisher = new JLabel();
  JLabel lblAuthor = new JLabel();
  JTextField txtISBN = new JTextField();
  JTextField txtPublisher = new JTextField();
  JTextField txtAuthor = new JTextField();
  JButton btnCreate = new JButton();
  JButton btnClose = new JButton();

  PnlAddLibraryBooks pnlAddLibraryBooks;
  Main main;
  JTextField txtTitle = new JTextField();
  JTextField txtAmount = new JTextField();
  JLabel lblTitle = new JLabel();
  JLabel lblAmount = new JLabel();

  public AddBooksFrame() {
    jbInit();
  }

  public AddBooksFrame(PnlAddLibraryBooks pnlAddLibraryBooks) {
    this.pnlAddLibraryBooks = pnlAddLibraryBooks;
    jbInit();
  }


  public AddBooksFrame(Main main) {
    this.main = main;
    jbInit();
  }

  private void jbInit() {
    this.getContentPane().setLayout(new GridLayout(6,2));
    this.setTitle("Inventory");

    lblISBN.setText("ISBN");
    lblPublisher.setText("Publisher");
    lblAuthor.setText("Author");
    btnCreate.setText("Creat");
    btnClose.setText("Close");
    btnClose.addActionListener(new java.awt.event.ActionListener() {

  public void actionPerformed(ActionEvent e) {
        btnClose_actionPerformed(e);
      }
    });

    btnCreate.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnCreate_actionPerformed(e);
      }
    });


    lblTitle.setText("Book Title");
    lblAmount.setText("Amount");
    txtTitle.setText("");
    this.getContentPane().add(lblISBN, null);
    this.getContentPane().add(txtISBN, null);

    this.getContentPane().add(lblPublisher, null);
    this.getContentPane().add(txtPublisher, null);

    this.getContentPane().add(lblAuthor, null);
    this.getContentPane().add(txtAuthor, null);

    this.getContentPane().add(lblTitle, null);
    this.getContentPane().add(txtTitle, null);

    this.getContentPane().add(lblAmount, null);
    this.getContentPane().add(txtAmount, null);

    this.getContentPane().add(btnCreate, null);
    this.getContentPane().add(btnClose, null);
  }

  void btnCreat_actionPerformed(ActionEvent e) {
    this.setVisible(false);
  }

  void btnCreate_actionPerformed(ActionEvent e) {
    try {
      create();
    } catch (Exception ex) {
      System.out.print("Error occured while creating Inventory");
    }
  }
  private void create() throws Exception{
    String isbn = this.txtISBN.getText();
    String publisher = this.txtPublisher.getText();
    String author = this.txtAuthor.getText();
    String title = this.txtTitle.getText();
    double amount = Double.parseDouble(this.txtAmount.getText());
    Book book = new Book(isbn, publisher,author, title, 1);
    main.addBook(book);
  }

  void btnClose_actionPerformed(ActionEvent e) {
    this.setVisible(false);
  }
}
