package gui_design_and_implimentation;

import java.util.Vector;

public class Book {

  private String ISBN;
  private String Publisher;
  private String Author;
  private String Title;
  private double Amount;

  public Book() {
  }

  public Book(String isbn, String publisher, String author, String title) {
    this(isbn, publisher,author, title, 1);
  }

  public Book(String isbn, String publisher, String author, String title, double amount) {
    this.ISBN = isbn;
    this.Publisher = publisher;
    this.Author = author;
    this.Title = title;
    this.Amount  = amount ;
  }


  public String getISBN() {
    return ISBN;
  }

  public String getPublisher() {
    return Publisher;
  }

  public String getAuthor() {
    return Author;
  }

  public String getTitle() {
    return Title;
  }

  public double getAmount() {
    return Amount;
  }


  public String toString() {
     return "ISBN: " + ISBN + ", Publisher: " + Publisher + ", Author: " + Author + ", Title: " + Title + "\n";
 }

 private Vector book;
 /////////////////////////////////
 /**
  * The one-to-Many association with inventoryItems
  * @param items
  */
 public void setBook(Vector newBook){
   this.book = newBook;
 }
 public Vector getBook(){
   return this.book;
 }
  /////////////////////////////////

}
