package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;
import javax.swing.border.*;

public class PnlMemberBooks extends JPanel {

  BorderLayout borderLayout1 = new BorderLayout();
  FlowLayout flowLayout1 = new FlowLayout();
  Membership membership = new Membership();
  JPanel pnlSouth = new JPanel();
  JButton btnPayFee = new JButton("Add Inventory");
  JScrollPane scroller = new JScrollPane();
  JTable membersBookTable = new JTable();
  LateFeeFrame lateFeeFrame;
  JButton btnRefresh = new JButton("Refresh");
  Vector columns = new Vector();
  Vector data = new Vector();
  Vector member = new Vector();
  DefaultTableModel model;
  Vector inventories = new Vector();
  JButton btnReturn = new JButton();

  public PnlMemberBooks() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(borderLayout1);

    pnlSouth.setLayout(flowLayout1);
    flowLayout1.setAlignment(flowLayout1.LEFT);
    btnPayFee.setText("Pay Fee");
    btnPayFee.addActionListener(new PnlMemberBooks_btnPayFee_actionAdapter(this));
    btnReturn.setEnabled(false);
    btnReturn.setMnemonic('0');
    btnReturn.setText("Return");
    btnRefresh.setEnabled(true);
    btnRefresh.addActionListener(new PnlMemberBooks_btnRefresh_actionAdapter(this));
    scroller.getViewport().add(membersBookTable, null);
    this.add(scroller, BorderLayout.CENTER);
    this.add(pnlSouth, BorderLayout.SOUTH);
    pnlSouth.add(btnReturn, null);
    pnlSouth.add(btnPayFee);
    pnlSouth.add(btnRefresh);

  }

  void btnPayFee_actionPerformed(ActionEvent e) {
    lateFeeFrame = new LateFeeFrame(this);
    lateFeeFrame.setVisible(true);
    lateFeeFrame.pack();
  }

  void btnRefresh_actionPerformed(ActionEvent e) {
    display();
  }

  private void setColumns(){
    columns.add("ISBN");
    columns.add("Publisher");
    columns.add("Author");
    columns.add("Title");
    columns.add("Amount");
  }

  private void display() {
    data = new Vector();
    member = membership.getMember().getMember();
/*
      for (int i =0; i<member.size(); i++) {
      Book libraryBooks = (Book) member.get(i);
      Vector row = new Vector();
      row.add(libraryBooks.getISBN());
      row.add(libraryBooks.getPublisher());
      row.add(libraryBooks.getAuthor());
      row.add(libraryBooks.getTitle());
      row.add(new Double(libraryBooks.getAmount()));
      data.add(row);
    }
    model = new DefaultTableModel(data, columns);
    membersBookTable.setModel(model);
*/
    System.out.println(member);
  }


}

class PnlMemberBooks_btnPayFee_actionAdapter implements java.awt.event.ActionListener {
  PnlMemberBooks adaptee;

  PnlMemberBooks_btnPayFee_actionAdapter(PnlMemberBooks adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnPayFee_actionPerformed(e);
  }
}

class PnlMemberBooks_btnRefresh_actionAdapter implements java.awt.event.ActionListener {
  PnlMemberBooks adaptee;

  PnlMemberBooks_btnRefresh_actionAdapter(PnlMemberBooks adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnRefresh_actionPerformed(e);
  }
}
