package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;
import com.borland.jbcl.layout.*;
import javax.swing.table.TableColumnModel;

public class PnlSelectMember extends JPanel {

  Membership membership = new Membership();
  Vector addMember = new Vector();
  Vector columns = new Vector();
  Vector data = new Vector();
  Vector books = new Vector();
  Main main;
  JScrollPane jScrollPane1 = new JScrollPane();
  JTable MemberTable = new JTable();
  DefaultTableModel model;
  BorderLayout borderLayout1 = new BorderLayout();


  public PnlSelectMember(Main main) {
    this.main = main;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    this.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(MemberTable, null);

    setColumns();
  }

  private void setColumns() {
    columns.add("Member Number");
    columns.add("Firstname");
    columns.add("Surname");
    columns.add("Telephone");
    columns.add("Street");
    columns.add("City");
    columns.add("Date Joined");
  }


  public void add(Member member) {
    addMember(member);
  }

  public void addMember(Member member) {
    this.addMember.add(member);
    this.membership.getMember().setMember(addMember);
    display();
  }

  public void addMemberBook(Member member) {
    this.addMember.add(member);
    this.membership.getMember().setBook(addMember);
  }

  private void display() {
    data = new Vector();
    books = membership.getMember().getMember();
    for (int i =0; i<books.size(); i++) {
      Member currentMembers = (Member) books.get(i);
      Vector row = new Vector();
      row.add(currentMembers.getMemberNumber());
      row.add(currentMembers.getFirstname());
      row.add(currentMembers.getSurname());
      row.add(currentMembers.getTelephone());
      row.add(currentMembers.getStreet());
      row.add(currentMembers.getCity());
      row.add(currentMembers.getAmount());
      data.add(row);
      System.out.println("Testing Library Book Storage"+"\n"+currentMembers);
    }
    model = new DefaultTableModel(data, columns);
    MemberTable.setModel(model);
  }

  public Vector getMember() {
    int row = MemberTable.getSelectedRow();
    Vector selectedMember = new Vector();
    TableColumnModel colModel = MemberTable.getColumnModel();
    String aMemberNumber = (String) MemberTable.getValueAt(row, 0);
    String aFirstname = (String) MemberTable.getValueAt(row, 1);
    String aSurname = (String) MemberTable.getValueAt(row, 2);
    String aTelephone = (String) MemberTable.getValueAt(row, 3);
    String aStreet = (String) MemberTable.getValueAt(row, 4);
    String aCity = (String) MemberTable.getValueAt(row, 5);
    String aAmount = (String) MemberTable.getValueAt(row, 6);
    selectedMember.add(aMemberNumber);
    selectedMember.add(aFirstname);
    selectedMember.add(aSurname);
    selectedMember.add(aTelephone);
    selectedMember.add(aStreet);
    selectedMember.add(aCity);
    selectedMember.add(aAmount);
    return selectedMember;
  }

}
